Option Strict Off
Option Explicit On
Friend Class Step4
	Inherits System.Windows.Forms.Form
	'Step 4 Specify reading area and cropping area.
	Private m_cscnPath As String 'path .bmp or .tif or .jpg
	Private m_lStoreIndex As Integer
	
	Private Sub cmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExit.Click
		
		'Close Aplication
		Me.Close()
		
	End Sub
	
	Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click
		
		'Data size clear
		Label1.Text = ""
		System.Windows.Forms.Application.DoEvents()
		
		With OPOSCheckScanner1
			
			'EventClear
			.ClearInput()
			
			'Ready to fired event
			.DataEventEnabled = True
			
			'Add timeout function.
			While .BeginInsertion(3000) = OPOS_E_TIMEOUT
				If (MsgBox("Please insert a check.", MsgBoxStyle.OKCancel + MsgBoxStyle.Question) = MsgBoxResult.Cancel) Then
					.EndInsertion()
					Exit Sub
				End If
				System.Windows.Forms.Application.DoEvents()
			End While
			
			'Set paper & Scanning
			.EndInsertion()
			
			'Call to retrieve an image to the ImageData proparty
			.RetrieveImage(CHK_CROP_AREA_ENTIRE_IMAGE)
			
			If .ResultCode = OPOS_SUCCESS Then
				'Enable "CroppingArea" Group
				Frame1.Enabled = True
				
				'Enable "Renge" Option
				Option1(0).Enabled = True
				Option1(1).Enabled = True
				Option1(2).Enabled = True
				Option1(0).Checked = True
			End If
			
		End With
		
	End Sub
	
	Private Sub Command2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command2.Click
		
		With OPOSCheckScanner1
			'Set FileID
			.FileID = "Epson CheckScanner SampleProgram Step4"
			
			'Set FileID
			.ImageTagData = "Epson CheckScanner SampleProgram Step4 ImageTagData"
			
			'Clear Image Data File
			.ClearImage(CHK_CLR_BY_FILEID)
			
			'StoreImage
			.StoreImage(m_lStoreIndex)
			
			'Displayed "rest number"
			Label3.Text = CStr(.RemainingImagesEstimate)
			
		End With
		
		MsgBox("A data was stored.")
		
	End Sub
	
	Private Sub Command3_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command3.Click
		
		'CreateFile
		Call CreateFile(GetDataSize)
		
		'CreateFile button Disable
		Command3.Enabled = False
		
		'finish message
		MsgBox("A file was created")
		
	End Sub
	
	Private Sub Option1_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Option1.CheckedChanged
		If eventSender.Checked Then
			Dim Index As Short = Option1.GetIndex(eventSender)
			
			Dim lCropAreaIndex As Integer
			
			lCropAreaIndex = Index + 1
			
			With OPOSCheckScanner1
				'Ready to fired event
				.DataEventEnabled = True
				
				Select Case Index
					Case 0
						.DefineCropArea(lCropAreaIndex, 0, 0, CHK_CROP_AREA_RIGHT, CHK_CROP_AREA_BOTTOM)
					Case 1
						.DefineCropArea(lCropAreaIndex, 3500, 2244, 2000, 456)
					Case 2
						.DefineCropArea(lCropAreaIndex, 5100, 236, 490, 214)
				End Select
				
				.RetrieveImage(lCropAreaIndex)
				
				m_lStoreIndex = lCropAreaIndex
				
			End With
			
		End If
	End Sub
	
	Private Sub Step4_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		
		Dim OBJChkScan As Object
		
		m_lStoreIndex = 1
		
		With OPOSCheckScanner1
			
			'Open the device
			'Use a Logical Device Name which has been set on the SetupPOS.
			.Open("Unit1")
			If .ResultCode <> OPOS_SUCCESS Then
				MsgBox("This device has not been registered, or cannot use.")
				GoTo LoadError
			End If
			
			'Get the exclusive control right for the opened device.
			'Then the device is disable from other application.
			'(Notice:When using an old CO, use the Claim.)
			.ClaimDevice(1000)
			If .ResultCode <> OPOS_SUCCESS Then
				MsgBox("Fails to get the exclusive right for the device.")
				GoTo LoadError
			End If
			
			'Power reporting
			If .CapPowerReporting <> OPOS_PR_NONE Then
				.PowerNotify = OPOS_PN_ENABLED
			End If
			
			'Enable the device.
			.DeviceEnabled = True
			If .ResultCode <> OPOS_SUCCESS Then
				MsgBox("Now the device is disable to use.")
				GoTo LoadError
			End If
			
			'Ready to fired event
			.DataEventEnabled = True
			
			'Read TIFF file
			.ImageFormat = CHK_IF_TIFF
			
			'Read BMP file format
			'.ImageFormat = CHK_IF_BMP
			
			'Read JPEG file format
			'.ImageFormat = CHK_IF_JPEG
			
			
			Select Case .ImageFormat
				Case CHK_IF_TIFF
					m_cscnPath = "\Step4.tif" 'case .tif
				Case CHK_IF_BMP
					m_cscnPath = "\Step4.bmp" 'case .bmp
				Case CHK_IF_JPEG
					m_cscnPath = "\Step4.jpg" 'case .jpg
				Case Else
					m_cscnPath = "\Step4.bmp" 'case .bmp
			End Select
			
		End With
		
		'Disable "Store" button
		Command2.Enabled = False
		
		'Disable "CreateFile" button
		Command3.Enabled = False
		
		'Disable "CroppingArea" Group
		Frame1.Enabled = False
		
		'Disable "Renge" Option
		Option1(0).Enabled = False
		Option1(1).Enabled = False
		Option1(2).Enabled = False
		
		Exit Sub
		
		'Go to
		'Disable button
LoadError: 
		
		For	Each OBJChkScan In Me.Controls
			If OBJChkScan.Name <> "OPOSCheckScanner1" Then
				OBJChkScan.Enabled = False
			End If
		Next OBJChkScan
		
		'Enabled exit button
		cmdExit.Enabled = True 'Only the exit button is enabled.
		
	End Sub
	
	Private Sub Step4_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
		
		With OPOSCheckScanner1
			
			'Cancel the device
			.DeviceEnabled = False
			
			'Release the device exclusive control right.
			'(Notice:When using an old CO, use the Release.)
			.ReleaseDevice()
			
			'Finish using the device.
			.Close()
			
		End With
		
	End Sub
	
	Private Sub OPOSCheckScanner1_ErrorEvent(ByVal eventSender As System.Object, ByVal eventArgs As AxOposCheckScanner_CCO._IOPOSCheckScannerEvents_ErrorEventEvent) Handles OPOSCheckScanner1.ErrorEvent
		
		'Error MessageBox
		MsgBox("CheckScanner Error!" & vbCrLf & vbCrLf & "ResultCode = " & CStr(eventArgs.ResultCode) & vbCrLf & "ResultCodeExtended = " & CStr(eventArgs.ResultCodeExtended))
		
		'Begin removal
		If eventArgs.ResultCode = OPOS_E_ILLEGAL Then
			With OPOSCheckScanner1
				.BeginRemoval(OPOS_FOREVER)
				.EndRemoval()
			End With
		End If
		
	End Sub
	
	Private Sub OPOSCheckScanner1_DataEvent(ByVal eventSender As System.Object, ByVal eventArgs As AxOposCheckScanner_CCO._IOPOSCheckScannerEvents_DataEventEvent) Handles OPOSCheckScanner1.DataEvent
		
		'Ready to fired event
		OPOSCheckScanner1.DataEventEnabled = True
		
		'Dispay ImageDataSize
		Label1.Text = CStr(GetDataSize) & " byte"
		
		'Enable "Store" button
		Command2.Enabled = True
		
		'Enable CreateFile button
		Command3.Enabled = True
		
	End Sub
	
	Private Function GetDataSize() As Integer
		
		Dim strIMSizeData As String
		Dim lImageDataSize As Integer
		Dim lNowBinaryConversion As Integer
		
		With OPOSCheckScanner1
			
			'Now BinaryConversion
			lNowBinaryConversion = .BinaryConversion
			
			'SetBinaryConversion
			.BinaryConversion = OPOS_BC_NIBBLE
			
			'Copy to ImageData
			strIMSizeData = .ImageData
			
			'GetDataSize
			lImageDataSize = Len(strIMSizeData) / 2
			
			'Re BinaryConversion
			.BinaryConversion = lNowBinaryConversion
			
		End With
		
		'Return ImageDataSize
		GetDataSize = lImageDataSize
		
	End Function
	
	Private Sub CreateFile(ByRef lImDataSize As Integer)
		
		Dim rtBNext As Integer 'See part of 2byte
		Dim rtBLen As Integer 'Byte Array Count
		Dim strHigh As String 'byte High
		Dim strLow As String 'byte Low
		Dim strIMData As String 'Main Data
		Dim bytTrans() As Byte 'dynamic array declaration statement
		Dim lNowBinaryConversion As Integer 'Now BinaryConversion
		
		rtBNext = 1 'start position
		
		With OPOSCheckScanner1
			
			'Now BinaryConversion
			lNowBinaryConversion = .BinaryConversion
			
			'SetBinaryConversion
			.BinaryConversion = OPOS_BC_NIBBLE
			
			'Copy to ImageData
			strIMData = .ImageData
			
			ReDim bytTrans(lImDataSize - 1) '2byte--->1byte
			
			For rtBLen = 0 To lImDataSize - 1
				strHigh = Mid(strIMData, rtBNext, 1) 'first string
				strLow = Mid(strIMData, rtBNext + 1, 1) 'second string
				rtBNext = rtBNext + 2
				bytTrans(rtBLen) = CByte(ChangeAsc(strHigh) * 16 + ChangeAsc(strLow))
				System.Windows.Forms.Application.DoEvents()
			Next rtBLen
			
			'Save file for binary mode
			FileOpen(1, My.Application.Info.DirectoryPath & m_cscnPath, OpenMode.Binary)
			FilePut(1, bytTrans)
			FileClose(1)
			
			'Re BinaryConversion
			.BinaryConversion = lNowBinaryConversion
			
		End With
		
	End Sub
	
	'change specialized epson string
	Private Function ChangeAsc(ByRef strCmd As String) As Byte
		
		Select Case strCmd
			Case ":"
				ChangeAsc = 10
			Case ";"
				ChangeAsc = 11
			Case "<"
				ChangeAsc = 12
			Case "="
				ChangeAsc = 13
			Case ">"
				ChangeAsc = 14
			Case "?"
				ChangeAsc = 15
			Case Else
				ChangeAsc = CByte(strCmd)
		End Select
		
	End Function
End Class