Option Strict Off
Option Explicit On
Friend Class Step9
	Inherits System.Windows.Forms.Form
	' Step 9 Print on slips.
	
	Private Structure ITEMDATA
		Dim Name_Renamed As String
		Dim Price As Integer
	End Structure
	
	Private Function MakePrintString(ByRef lRecLineChars As Integer, ByRef sBuf As String, ByRef sPrice As String) As Object
		Dim sValue As String
		If lRecLineChars < (Len(sBuf) + Len(sPrice)) Then
			sValue = sBuf & sPrice
		Else
			sValue = sBuf & Space(lRecLineChars - (Len(sBuf) + Len(sPrice))) & sPrice
		End If
		
		MakePrintString = sValue
	End Function
	
	Private Sub cmdPrint_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdPrint.Click
		
		Dim lValue As Integer
		Dim i As Short
		Dim idBuf(5) As ITEMDATA
		Dim ESC As New VB6.FixedLengthString(1)
		Dim fDate As String
		Dim BcData As String
		Dim sBuf As String
		Dim sPrice As String
		Dim sValue As String
		Dim sRecLineChars() As String
		Dim lRecLineCharsCount As Integer
		
		Cursor = System.Windows.Forms.Cursors.WaitCursor
		
		ESC.Value = Chr(&H1B)
		fDate = VB6.Format(Now, "mmmm dd, yyyy  AM/PM h:mm")
		BcData = "4902720005074"
		
		' Make a data of the buying goods
		idBuf(0).Name_Renamed = "apples" : idBuf(0).Price = 10
		idBuf(1).Name_Renamed = "grapes" : idBuf(1).Price = 20
		idBuf(2).Name_Renamed = "bananas" : idBuf(2).Price = 30
		idBuf(3).Name_Renamed = "lemons" : idBuf(3).Price = 40
		idBuf(4).Name_Renamed = "oranges" : idBuf(4).Price = 50
		
		With OPOSPOSPrinter1
			.TransactionPrint(PTR_S_RECEIPT, PTR_TP_TRANSACTION)
			
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|1B")
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|N" & "123xxstreet,xxxcity,xxxxstate " & vbLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|rA" & "TEL 9999-99-9999   C#2" & vbLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|200uF")
			
			'Change of the font size
			lRecLineCharsCount = GetRecLineChars(sRecLineChars)
			If lRecLineCharsCount >= 2 Then
				.RecLineChars = CInt(sRecLineChars(1))
				.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|cA" & fDate & vbLf)
				.RecLineChars = CInt(sRecLineChars(0))
			Else
				.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|cA" & fDate & vbLf)
			End If
			
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|500uF")
			'Print buying goods
			lValue = 0
			For i = LBound(idBuf) To UBound(idBuf) - 1
				If .ResultCode <> OPOS_SUCCESS Then Exit For
				sBuf = idBuf(i).Name_Renamed
				lValue = lValue + idBuf(i).Price
				sPrice = VB6.Format(idBuf(i).Price, "$#.00")
				sValue = MakePrintString(.RecLineChars, sBuf, sPrice)
				.PrintNormal(PTR_S_RECEIPT, sValue & vbLf)
			Next 
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|200uF")
			'Print the total cost
			sBuf = "Before adding tax"
			sPrice = VB6.Format(lValue, "$#.00")
			sValue = MakePrintString(.RecLineChars, sBuf, sPrice)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|bC" & sValue & vbLf)
			sBuf = "tax   5.0%"
			sPrice = VB6.Format(lValue * 0.05, "$#.00")
			sValue = MakePrintString(.RecLineChars, sBuf, sPrice)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|N" & ESC.Value & "|uC" & sValue & vbLf)
			sBuf = "total"
			sPrice = VB6.Format(lValue * 1.05, "$#.00")
			sValue = MakePrintString(.RecLineChars \ 2, sBuf, sPrice)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|N" & ESC.Value & "|bC" & ESC.Value & "|2C" & sValue & vbLf)
			sBuf = "Customer's payment"
			sPrice = VB6.Format(200, "$#.00")
			sValue = MakePrintString(.RecLineChars, sBuf, sPrice)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|N" & sValue & vbLf)
			sBuf = "Change"
			sPrice = VB6.Format(200 - lValue * 1.05, "$#.00")
			sValue = MakePrintString(.RecLineChars, sBuf, sPrice)
			.PrintNormal(PTR_S_RECEIPT, sValue & vbLf)
			
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|500uF")
			.PrintBarCode(PTR_S_RECEIPT, BcData, PTR_BCS_JAN13, 1000, .RecLineWidth, PTR_BC_CENTER, PTR_BC_TEXT_BELOW)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|fP")
			
			.TransactionPrint(PTR_S_RECEIPT, PTR_TP_NORMAL)
		End With
		
		Cursor = System.Windows.Forms.Cursors.Default
		
	End Sub
	
	Private Function GetRecLineChars(ByRef sRecLineChars() As String) As Object
		Dim lIndex As Integer
		Dim lCount As Integer
		Dim sRecLineCharsList As String
		Dim i As Short
		Dim lStartIndex As Integer
		Dim lEndIndex As Integer
		
		
		sRecLineCharsList = OPOSPOSPrinter1.RecLineCharsList
		
		If Len(sRecLineCharsList) = 0 Then
			GetRecLineChars = 0
		Else
			'Calculate the element count.
			lCount = 1
			lIndex = InStr(1, sRecLineCharsList, ",")
			While lIndex <> 0
				lCount = lCount + 1
				lIndex = lIndex + 1
				lIndex = InStr(lIndex, sRecLineCharsList, ",")
			End While
			
			'Set the element to array.
			ReDim sRecLineChars(lCount)
			
			lStartIndex = 1
			For i = 0 To lCount - 1
				lEndIndex = InStr(lStartIndex, sRecLineCharsList, ",")
				If lEndIndex = 0 Then
					lEndIndex = Len(sRecLineCharsList)
				End If
				
				sRecLineChars(i) = Mid(sRecLineCharsList, lStartIndex, lEndIndex - 1)
				lStartIndex = lEndIndex + 1
			Next 
			
			GetRecLineChars = lCount
			
		End If
		
	End Function
	
	Private Sub cmdAsync_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdAsync.Click
		
		Dim lValue As Integer
		Dim i As Short
		Dim idBuf(5) As ITEMDATA
		Dim ESC As New VB6.FixedLengthString(1)
		Dim fDate As String
		Dim BcData As String
		Dim sBuf As String
		Dim sPrice As String
		Dim sValue As String
		
		Cursor = System.Windows.Forms.Cursors.WaitCursor
		
		ESC.Value = Chr(&H1B)
		fDate = VB6.Format(Now, "mmmm dd, yyyy  AM/PM h:mm")
		BcData = "4902720005074"
		
		' Make a data of the buying goods
		idBuf(0).Name_Renamed = "apples" : idBuf(0).Price = 10
		idBuf(1).Name_Renamed = "grapes" : idBuf(1).Price = 20
		idBuf(2).Name_Renamed = "bananas" : idBuf(2).Price = 30
		idBuf(3).Name_Renamed = "lemons" : idBuf(3).Price = 40
		idBuf(4).Name_Renamed = "oranges" : idBuf(4).Price = 50
		
		With OPOSPOSPrinter1
			.AsyncMode = True
			.TransactionPrint(PTR_S_RECEIPT, PTR_TP_TRANSACTION)
			
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|1B")
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|N" & "123xxstreet,xxxcity,xxxxstate " & vbLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|rA" & "TEL 9999-99-9999   C#2" & vbLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|200uF")
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|cA" & fDate & vbLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|500uF")
			'Print buying goods
			lValue = 0
			For i = LBound(idBuf) To UBound(idBuf) - 1
				If .ResultCode <> OPOS_SUCCESS Then Exit For
				sBuf = idBuf(i).Name_Renamed
				lValue = lValue + idBuf(i).Price
				sPrice = VB6.Format(idBuf(i).Price, "$#.00")
				sValue = MakePrintString(.RecLineChars, sBuf, sPrice)
				.PrintNormal(PTR_S_RECEIPT, sValue & vbLf)
			Next 
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|200uF")
			'Print the total cost
			sBuf = "Tax excluded."
			sPrice = VB6.Format(lValue, "$#.00")
			sValue = MakePrintString(.RecLineChars, sBuf, sPrice)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|bC" & sValue & vbLf)
			sBuf = "Tax  5.0%"
			sPrice = VB6.Format(lValue * 0.05, "$#.00")
			sValue = MakePrintString(.RecLineChars, sBuf, sPrice)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|N" & ESC.Value & "|uC" & sValue & vbLf)
			sBuf = "Total"
			sPrice = VB6.Format(lValue * 1.05, "$#.00")
			sValue = MakePrintString(.RecLineChars \ 2, sBuf, sPrice) 'Because the width of characters of total is doubled, take this into consideration when computing.
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|N" & ESC.Value & "|bC" & ESC.Value & "|2C" & sValue & vbLf)
			sBuf = "Customer's payment"
			sPrice = VB6.Format(200, "$#.00")
			sValue = MakePrintString(.RecLineChars, sBuf, sPrice)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|N" & sValue & vbLf)
			sBuf = "Change"
			sPrice = VB6.Format(200 - lValue * 1.05, "$#.00")
			sValue = MakePrintString(.RecLineChars, sBuf, sPrice)
			.PrintNormal(PTR_S_RECEIPT, sValue & vbLf)
			
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|500uF")
			.PrintBarCode(PTR_S_RECEIPT, BcData, PTR_BCS_JAN13, 1000, .RecLineWidth, PTR_BC_CENTER, PTR_BC_TEXT_BELOW)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|fP")
			
			.TransactionPrint(PTR_S_RECEIPT, PTR_TP_NORMAL)
			.AsyncMode = False
		End With
		
		Cursor = System.Windows.Forms.Cursors.Default
		
	End Sub
	
	Private Sub cmdReceipt_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdReceipt.Click
		
		Dim rcSpacing As Integer
		Dim rcHeight As Integer
		Dim ESC As New VB6.FixedLengthString(1)
		Dim fDate As String
		
		Cursor = System.Windows.Forms.Cursors.WaitCursor
		
		ESC.Value = Chr(&H1B)
		fDate = VB6.Format(Now, "mmmm dd, yyyy  AM/PM h:mm")
		
		With OPOSPOSPrinter1
			rcSpacing = .RecLineSpacing 'Keep the default line spacing
			rcHeight = .RecLineHeight 'Keep the default line height
			.TransactionPrint(PTR_S_RECEIPT, PTR_TP_TRANSACTION)
			
			.RotatePrint(PTR_S_RECEIPT, PTR_RP_LEFT90)
			
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|4C" & ESC.Value & "|bC" & "   Receipt     ")
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|3C" & ESC.Value & "|2uC" & "       Mr. Brawn" & vbCrLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|2uC" & "                                                  " & vbCrLf & vbCrLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|2uC" & ESC.Value & "|3C" & "        Total payment              $" & ESC.Value & "|4C" & "21.00  " & vbCrLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|1C" & vbCrLf)
			.PrintNormal(PTR_S_RECEIPT, fDate & " Received" & vbCrLf & vbCrLf)
			.RecLineHeight = 24
			.RecLineSpacing = .RecLineHeight
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|uC" & " Details               " & vbCrLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|1C" & "                          " & ESC.Value & "|2C" & "OPOS Store" & vbCrLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|uC" & " Tax excluded    $20.00" & vbCrLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|1C" & "                          " & ESC.Value & "|bC" & "Zip code 999-9999" & vbCrLf)
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|uC" & " Tax(5%)        $1.00" & ESC.Value & "|N" & "    Phone#(9999)99-9998" & vbCrLf)
			
			.RotatePrint(PTR_S_RECEIPT, PTR_RP_NORMAL)
			
			.PrintNormal(PTR_S_RECEIPT, ESC.Value & "|fP")
			
			' Wait until device is 'OPOS_S_IDLE'
			While .CtlState <> OPOS_S_IDLE
			End While
			'Print all the buffer data, and exit the batch processing mode.
			.TransactionPrint(PTR_S_RECEIPT, PTR_TP_NORMAL)
			
			.RecLineSpacing = rcSpacing
			.RecLineHeight = rcHeight
		End With
		
		Cursor = System.Windows.Forms.Cursors.Default
		
	End Sub
	
	'<<< Step 9 >>>
	'
	Private Sub cmdPrintSales_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdPrintSales.Click
		
		Dim RecNo As Integer
		Dim ESC As New VB6.FixedLengthString(1)
		Dim fDate As String
		Dim fTime As String
		Dim fRecNo As String
		Dim fName As String
		Dim fSpace As String
		Dim OutputData As String
		
		'Request for inserting a slip
		Do 
			Select Case MsgBox("Insert Slip", MsgBoxStyle.OKCancel + MsgBoxStyle.Information)
				Case MsgBoxResult.OK 'seleced OK
					With OPOSPOSPrinter1
						.BeginInsertion(5000) 'wait time is 5 minute from set paper
						.EndInsertion()
						' Insert paper is success to loop out
						If .ResultCode = OPOS_SUCCESS Then Exit Do
					End With
				Case MsgBoxResult.Cancel ' selected Cancel
					Exit Sub 'Exit disposal
			End Select
		Loop 
		
		' Initialization
		Cursor = System.Windows.Forms.Cursors.WaitCursor
		ESC.Value = Chr(&H1B)
		fDate = VB6.Format(Today, "mmmm dd, yyyy") 'System date
		fTime = VB6.Format(TimeOfDay, "h:mm") 'System time
		RecNo = 1 'Register No.
		fRecNo = VB6.Format(RecNo, "  0000")
		fName = "ABCDEF" 'Casher No.
		If OPOSPOSPrinter1.SlpLineChars > 33 Then
			fSpace = Space(OPOSPOSPrinter1.SlpLineChars - 33) 'Left space
		Else
			fSpace = ""
		End If
		
		' Print data
		OutputData = vbCrLf & fSpace & "Print credit card sales slip" & vbCrLf
		OutputData = OutputData & ESC.Value & "|1lF"
		OutputData = OutputData & fSpace & "        SEIKO EPSON Corp." & vbCrLf
		OutputData = OutputData & fSpace & "Thank you for coming to our shop!" & vbCrLf
		OutputData = OutputData & ESC.Value & "|1lF"
		OutputData = OutputData & fSpace & "Date " & fDate & vbCrLf
		OutputData = OutputData & fSpace & "Time      " & fTime & "Casher   " & fName & vbCrLf
		OutputData = OutputData & fSpace & "Number of the register" & fRecNo & vbCrLf
		OutputData = OutputData & ESC.Value & "|N" & ESC.Value & "|1lF"
		OutputData = OutputData & fSpace & "Details                      cost" & vbCrLf
		OutputData = OutputData & fSpace & "Cardigan                 $ 100.00" & vbCrLf
		OutputData = OutputData & fSpace & "Shoes                     $ 70.00" & vbCrLf
		OutputData = OutputData & fSpace & "Hat                       $ 30.00" & vbCrLf
		OutputData = OutputData & fSpace & "Bag                      $ 150.00" & vbCrLf
		OutputData = OutputData & fSpace & "        Excluded tax     $ 350.00" & vbCrLf
		OutputData = OutputData & fSpace & "        Tax(5%)           $ 17.50" & vbCrLf
		OutputData = OutputData & fSpace & "        -------------------------" & vbCrLf
		OutputData = OutputData & fSpace & ESC.Value & "|2C     Total" & ESC.Value & "|1C     $ 367.50" & vbCrLf
		OutputData = OutputData & ESC.Value & "|1lF"
		OutputData = OutputData & fSpace & "Company name   EPSON-CARD" & vbCrLf
		OutputData = OutputData & fSpace & "Membership No. XXXXXXXXXXXXXXXX" & vbCrLf
		OutputData = OutputData & fSpace & "Valid date     12/05" & vbCrLf
		OutputData = OutputData & fSpace & "Handling No.   9999 - 999999" & vbCrLf
		OutputData = OutputData & fSpace & "Approval No.   99" & vbCrLf
		OutputData = OutputData & ESC.Value & "|1lF"
		OutputData = OutputData & fSpace & "Signature" & vbCrLf
		' Printing process
		OPOSPOSPrinter1.PrintNormal(PTR_S_SLIP, OutputData)
		
		' Clean up
		Cursor = System.Windows.Forms.Cursors.Default
		
		'Remove the slip at the slip station.
		With OPOSPOSPrinter1
			.BeginRemoval(10000)
			.EndRemoval()
		End With
		
	End Sub
	
	Private Sub cmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExit.Click
		
		Me.Close()
		
	End Sub
	
	Private Sub OPOSPOSPrinter1_OutputCompleteEvent(ByVal eventSender As System.Object, ByVal eventArgs As AxOposPOSPrinter_CCO._IOPOSPOSPrinterEvents_OutputCompleteEventEvent) Handles OPOSPOSPrinter1.OutputCompleteEvent
		
		'Notify that printing is completed when it is asnchronous.
		MsgBox("Complete printing", MsgBoxStyle.Information)
		
	End Sub
	
	
	Private Sub Step9_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		
		With OPOSPOSPrinter1
			.Open("Unit1")
			.ClaimDevice(1000)
			.DeviceEnabled = True
			
			.MapMode = PTR_MM_METRIC
			.RecLetterQuality = True
			
			If .CapRecBitmap = True Then
				.SetBitmap(1, PTR_S_RECEIPT, My.Application.Info.DirectoryPath & "\Logo.bmp", .RecLineWidth / 2, PTR_BM_CENTER)
			End If
			
			'Check on rotation print function
			If (.CapRecLeft90 = False) Or (.CapRecRight90 = False) Then
				' Not function to [Print Receipt] button is disable
				cmdReceipt.Enabled = False
			End If
			' <<< Step 9 >>>
			'Check on slip function
			If (.CapSlpPresent = False) Or (.CapSlpFullslip = False) Then
				' Not function to [Print Sales Slip] button is disable
				cmdPrintSales.Enabled = False
			End If
		End With
		
	End Sub
	
	Private Sub Step9_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
		
		With OPOSPOSPrinter1
			.DeviceEnabled = False
			.ReleaseDevice()
			.Close()
		End With
		
	End Sub
End Class